import rospy
from time import sleep
import intera_interface
from geometry_msgs.msg import Pose

if __name__=="__main__":
    rospy.init_node("sawyer_controller")
    limb = intera_interface.Limb("right")
    angles = limb.joint_angles()

    for k in angles:
        angles[k]=0.0
    limb.move_to_neutral()
    sleep(10)

    # Inverse Kinematics
    pose0 = Pose()
    pose0.position.x = 1.0155
    pose0.position.y = 0.158
    pose0.position.z = 0.3157

    pose0.orientation.x = 0.544
    pose0.orientation.y = -0.45
    pose0.orientation.z = 0.544
    pose0.orientation.w = -0.45

    angles_from_ik = limb.ik_request(pose0)
    limb.move_to_joint_positions(angles_from_ik)

    # Forward Kinematics 
    limb.fk_request(angles_from_ik)

