# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from intera_core_msgs/AssemblyState.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class AssemblyState(genpy.Message):
  _md5sum = "1dd1da5d897074cd1eece6cc0449a2eb"
  _type = "intera_core_msgs/AssemblyState"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """bool ready               # true if enabled and ready to operate, e.g., not homing
bool enabled             # true if enabled
bool stopped             # true if stopped -- e-stop asserted
bool error               # true if a component of the assembly has an error
bool lowVoltage          # true when the robot is in low voltage mode
#
# The following are specific to the robot top-level assembly:
uint8  estop_button      # One of the following:
  uint8   ESTOP_BUTTON_UNPRESSED = 0   # Robot is not stopped and button is not pressed
  uint8   ESTOP_BUTTON_PRESSED   = 1
  uint8   ESTOP_BUTTON_UNKNOWN   = 2   # STATE_UNKNOWN when estop was asserted by a non-user source
  uint8   ESTOP_BUTTON_RELEASED  = 3   # Was pressed, is now known to be released, but robot is still stopped.
#
uint8  estop_source      # If stopped is true, the source of the e-stop.  One of the following:
  uint8  ESTOP_SOURCE_NONE      = 0   # e-stop is not asserted
  uint8  ESTOP_SOURCE_USER      = 1   # e-stop source is user input (the red button)
  uint8  ESTOP_SOURCE_UNKNOWN   = 2   # e-stop source is unknown
  uint8  ESTOP_SOURCE_FAULT     = 3   # MotorController asserted e-stop in response to a joint fault
  uint8  ESTOP_SOURCE_BRAIN     = 4   # MotorController asserted e-stop in response to a lapse of the brain heartbeat
"""
  # Pseudo-constants
  ESTOP_BUTTON_UNPRESSED = 0
  ESTOP_BUTTON_PRESSED = 1
  ESTOP_BUTTON_UNKNOWN = 2
  ESTOP_BUTTON_RELEASED = 3
  ESTOP_SOURCE_NONE = 0
  ESTOP_SOURCE_USER = 1
  ESTOP_SOURCE_UNKNOWN = 2
  ESTOP_SOURCE_FAULT = 3
  ESTOP_SOURCE_BRAIN = 4

  __slots__ = ['ready','enabled','stopped','error','lowVoltage','estop_button','estop_source']
  _slot_types = ['bool','bool','bool','bool','bool','uint8','uint8']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       ready,enabled,stopped,error,lowVoltage,estop_button,estop_source

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(AssemblyState, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.ready is None:
        self.ready = False
      if self.enabled is None:
        self.enabled = False
      if self.stopped is None:
        self.stopped = False
      if self.error is None:
        self.error = False
      if self.lowVoltage is None:
        self.lowVoltage = False
      if self.estop_button is None:
        self.estop_button = 0
      if self.estop_source is None:
        self.estop_source = 0
    else:
      self.ready = False
      self.enabled = False
      self.stopped = False
      self.error = False
      self.lowVoltage = False
      self.estop_button = 0
      self.estop_source = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_7B().pack(_x.ready, _x.enabled, _x.stopped, _x.error, _x.lowVoltage, _x.estop_button, _x.estop_source))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      end = 0
      _x = self
      start = end
      end += 7
      (_x.ready, _x.enabled, _x.stopped, _x.error, _x.lowVoltage, _x.estop_button, _x.estop_source,) = _get_struct_7B().unpack(str[start:end])
      self.ready = bool(self.ready)
      self.enabled = bool(self.enabled)
      self.stopped = bool(self.stopped)
      self.error = bool(self.error)
      self.lowVoltage = bool(self.lowVoltage)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_7B().pack(_x.ready, _x.enabled, _x.stopped, _x.error, _x.lowVoltage, _x.estop_button, _x.estop_source))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      end = 0
      _x = self
      start = end
      end += 7
      (_x.ready, _x.enabled, _x.stopped, _x.error, _x.lowVoltage, _x.estop_button, _x.estop_source,) = _get_struct_7B().unpack(str[start:end])
      self.ready = bool(self.ready)
      self.enabled = bool(self.enabled)
      self.stopped = bool(self.stopped)
      self.error = bool(self.error)
      self.lowVoltage = bool(self.lowVoltage)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_7B = None
def _get_struct_7B():
    global _struct_7B
    if _struct_7B is None:
        _struct_7B = struct.Struct("<7B")
    return _struct_7B
