# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from intera_motion_msgs/EndpointTrackingError.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg
import std_msgs.msg

class EndpointTrackingError(genpy.Message):
  _md5sum = "c266cbf60fc5f871b5909394c05032fc"
  _type = "intera_motion_msgs/EndpointTrackingError"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """# This message will be published from the TrackingController
# It contains the endpoint tracking error data for diagnostics.
Header header

# ID for the trajectory.
uint32 trajectory_id

# Reference time since start of trajectory in seconds.
float64 trajectory_time

# Name of the endpoint that is currently active (coordinate frame name)
string active_endpoint

# pose_error transforms from pose_command to pose_measured
# units: translation (meters) ; orientation (quaternion)
geometry_msgs/Pose pose_error

# twist_error = twist_measured) - twist_command
# units: linear (meters) ; angular (radians per second)
geometry_msgs/Twist twist_error

# pose that is commanded at the active_endpoint
# units: translation (meters) ; orientation (quaternion)
geometry_msgs/Pose pose_command

# twist that is commanded at the active_endpoint
# units: linear (meters) ; angular (radians per second)
geometry_msgs/Twist twist_command

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of position and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: geometry_msgs/Twist
# This expresses velocity in free space broken into its linear and angular parts.
Vector3  linear
Vector3  angular

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 
# It is only meant to represent a direction. Therefore, it does not
# make sense to apply a translation to it (e.g., when applying a 
# generic rigid transformation to a Vector3, tf2 will only apply the
# rotation). If you want your data to be translatable too, use the
# geometry_msgs/Point message instead.

float64 x
float64 y
float64 z"""
  __slots__ = ['header','trajectory_id','trajectory_time','active_endpoint','pose_error','twist_error','pose_command','twist_command']
  _slot_types = ['std_msgs/Header','uint32','float64','string','geometry_msgs/Pose','geometry_msgs/Twist','geometry_msgs/Pose','geometry_msgs/Twist']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,trajectory_id,trajectory_time,active_endpoint,pose_error,twist_error,pose_command,twist_command

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(EndpointTrackingError, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.trajectory_id is None:
        self.trajectory_id = 0
      if self.trajectory_time is None:
        self.trajectory_time = 0.
      if self.active_endpoint is None:
        self.active_endpoint = ''
      if self.pose_error is None:
        self.pose_error = geometry_msgs.msg.Pose()
      if self.twist_error is None:
        self.twist_error = geometry_msgs.msg.Twist()
      if self.pose_command is None:
        self.pose_command = geometry_msgs.msg.Pose()
      if self.twist_command is None:
        self.twist_command = geometry_msgs.msg.Twist()
    else:
      self.header = std_msgs.msg.Header()
      self.trajectory_id = 0
      self.trajectory_time = 0.
      self.active_endpoint = ''
      self.pose_error = geometry_msgs.msg.Pose()
      self.twist_error = geometry_msgs.msg.Twist()
      self.pose_command = geometry_msgs.msg.Pose()
      self.twist_command = geometry_msgs.msg.Twist()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_get_struct_Id().pack(_x.trajectory_id, _x.trajectory_time))
      _x = self.active_endpoint
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_get_struct_26d().pack(_x.pose_error.position.x, _x.pose_error.position.y, _x.pose_error.position.z, _x.pose_error.orientation.x, _x.pose_error.orientation.y, _x.pose_error.orientation.z, _x.pose_error.orientation.w, _x.twist_error.linear.x, _x.twist_error.linear.y, _x.twist_error.linear.z, _x.twist_error.angular.x, _x.twist_error.angular.y, _x.twist_error.angular.z, _x.pose_command.position.x, _x.pose_command.position.y, _x.pose_command.position.z, _x.pose_command.orientation.x, _x.pose_command.orientation.y, _x.pose_command.orientation.z, _x.pose_command.orientation.w, _x.twist_command.linear.x, _x.twist_command.linear.y, _x.twist_command.linear.z, _x.twist_command.angular.x, _x.twist_command.angular.y, _x.twist_command.angular.z))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.pose_error is None:
        self.pose_error = geometry_msgs.msg.Pose()
      if self.twist_error is None:
        self.twist_error = geometry_msgs.msg.Twist()
      if self.pose_command is None:
        self.pose_command = geometry_msgs.msg.Pose()
      if self.twist_command is None:
        self.twist_command = geometry_msgs.msg.Twist()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 12
      (_x.trajectory_id, _x.trajectory_time,) = _get_struct_Id().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.active_endpoint = str[start:end].decode('utf-8')
      else:
        self.active_endpoint = str[start:end]
      _x = self
      start = end
      end += 208
      (_x.pose_error.position.x, _x.pose_error.position.y, _x.pose_error.position.z, _x.pose_error.orientation.x, _x.pose_error.orientation.y, _x.pose_error.orientation.z, _x.pose_error.orientation.w, _x.twist_error.linear.x, _x.twist_error.linear.y, _x.twist_error.linear.z, _x.twist_error.angular.x, _x.twist_error.angular.y, _x.twist_error.angular.z, _x.pose_command.position.x, _x.pose_command.position.y, _x.pose_command.position.z, _x.pose_command.orientation.x, _x.pose_command.orientation.y, _x.pose_command.orientation.z, _x.pose_command.orientation.w, _x.twist_command.linear.x, _x.twist_command.linear.y, _x.twist_command.linear.z, _x.twist_command.angular.x, _x.twist_command.angular.y, _x.twist_command.angular.z,) = _get_struct_26d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_get_struct_Id().pack(_x.trajectory_id, _x.trajectory_time))
      _x = self.active_endpoint
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_get_struct_26d().pack(_x.pose_error.position.x, _x.pose_error.position.y, _x.pose_error.position.z, _x.pose_error.orientation.x, _x.pose_error.orientation.y, _x.pose_error.orientation.z, _x.pose_error.orientation.w, _x.twist_error.linear.x, _x.twist_error.linear.y, _x.twist_error.linear.z, _x.twist_error.angular.x, _x.twist_error.angular.y, _x.twist_error.angular.z, _x.pose_command.position.x, _x.pose_command.position.y, _x.pose_command.position.z, _x.pose_command.orientation.x, _x.pose_command.orientation.y, _x.pose_command.orientation.z, _x.pose_command.orientation.w, _x.twist_command.linear.x, _x.twist_command.linear.y, _x.twist_command.linear.z, _x.twist_command.angular.x, _x.twist_command.angular.y, _x.twist_command.angular.z))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.pose_error is None:
        self.pose_error = geometry_msgs.msg.Pose()
      if self.twist_error is None:
        self.twist_error = geometry_msgs.msg.Twist()
      if self.pose_command is None:
        self.pose_command = geometry_msgs.msg.Pose()
      if self.twist_command is None:
        self.twist_command = geometry_msgs.msg.Twist()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 12
      (_x.trajectory_id, _x.trajectory_time,) = _get_struct_Id().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.active_endpoint = str[start:end].decode('utf-8')
      else:
        self.active_endpoint = str[start:end]
      _x = self
      start = end
      end += 208
      (_x.pose_error.position.x, _x.pose_error.position.y, _x.pose_error.position.z, _x.pose_error.orientation.x, _x.pose_error.orientation.y, _x.pose_error.orientation.z, _x.pose_error.orientation.w, _x.twist_error.linear.x, _x.twist_error.linear.y, _x.twist_error.linear.z, _x.twist_error.angular.x, _x.twist_error.angular.y, _x.twist_error.angular.z, _x.pose_command.position.x, _x.pose_command.position.y, _x.pose_command.position.z, _x.pose_command.orientation.x, _x.pose_command.orientation.y, _x.pose_command.orientation.z, _x.pose_command.orientation.w, _x.twist_command.linear.x, _x.twist_command.linear.y, _x.twist_command.linear.z, _x.twist_command.angular.x, _x.twist_command.angular.y, _x.twist_command.angular.z,) = _get_struct_26d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_Id = None
def _get_struct_Id():
    global _struct_Id
    if _struct_Id is None:
        _struct_Id = struct.Struct("<Id")
    return _struct_Id
_struct_26d = None
def _get_struct_26d():
    global _struct_26d
    if _struct_26d is None:
        _struct_26d = struct.Struct("<26d")
    return _struct_26d
